package domain;

import javax.persistence.*;
import javax.xml.bind.annotation.XmlRootElement;
import java.io.Serializable;
import java.util.Set;

@Entity
@Table(name="employees",schema="public")
@NamedQuery(name="Employee.findAll", query="SELECT e FROM Employee e")
public class Employee implements Serializable{

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE,generator="id_sequence")
    private Long id;

    @Column(name = "name_and_title")
    private String nameAndTitle;

    @Column(name="relation_name")
    private String relationName;

    @Column(name="relation_position")
    private String relationPosition;

    @OneToMany(cascade = {CascadeType.ALL})
    @JoinColumn(name="employee_id")
    private Set<EmployeePhoneNumber> employeePhoneNumbers;

    @OneToMany(cascade = {CascadeType.ALL})
    @JoinColumn(name="employee_id")
    private Set<EmployeePlace> employeePlaces;

    @OneToMany(cascade = {CascadeType.ALL})
    @JoinColumn(name="employee_id")
    private Set<EmployeePublication> employeePublications;

    @OneToMany(cascade = {CascadeType.ALL})
    @JoinColumn(name="employee_id")
    private Set<EmployeeVoip> employeeVoips;

    @OneToMany(cascade = {CascadeType.ALL})
    @JoinColumn(name="employee_id")
    private Set<EmployeeWeb> employeeWebs;

    public String getRelationName() {
        return relationName;
    }

    public void setRelationName(String relationName) {
        this.relationName = relationName;
    }

    public String getRelationPosition() {
        return relationPosition;
    }

    public void setRelationPosition(String relationPosition) {
        this.relationPosition = relationPosition;
    }

    public Set<EmployeeWeb> getEmployeeWebs() {
        return employeeWebs;
    }

    public void setEmployeeWebs(Set<EmployeeWeb> employeeWebs) {
        this.employeeWebs = employeeWebs;
    }

    public Set<EmployeeVoip> getEmployeeVoips() {
        return employeeVoips;
    }

    public void setEmployeeVoips(Set<EmployeeVoip> employeeVoips) {
        this.employeeVoips = employeeVoips;
    }

    public Set<EmployeePublication> getEmployeePublications() {
        return employeePublications;
    }

    public void setEmployeePublications(Set<EmployeePublication> employeePublications) {
        this.employeePublications = employeePublications;
    }

    public Set<EmployeePlace> getEmployeePlaces() {
        return employeePlaces;
    }

    public void setEmployeePlaces(Set<EmployeePlace> employeePlaces) {
        this.employeePlaces = employeePlaces;
    }

    public Set<EmployeePhoneNumber> getEmployeePhoneNumbers() {
        return employeePhoneNumbers;
    }

    public void setEmployeePhoneNumbers(Set<EmployeePhoneNumber> employeePhoneNumbers) {
        this.employeePhoneNumbers = employeePhoneNumbers;
    }

    public Employee() {
    }


    public Employee(String nameAndTitle) {
        this.nameAndTitle = nameAndTitle;
    }



    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }


    public String getNameAndTitle() {
        return nameAndTitle;
    }

    public void setNameAndTitle(String nameAndTitle) {
        this.nameAndTitle = nameAndTitle;
    }
}
