package service;

import com.google.gson.Gson;
import domain.Canteen;
import webservice.HTMLParserFreeFood;

import javax.ejb.Stateless;
import javax.inject.Inject;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import javax.persistence.TypedQuery;
import java.util.List;

@Stateless
public class CanteenService {

    @Inject
    private HTMLParserFreeFood parser;

    @PersistenceContext
    private EntityManager em;

    public String getCanteen(Long id){
        Canteen canteen = em.find(Canteen.class, id);
        return canteen.getName();
    }
    public String parseAndCreateFreeFood(){
        parser.parseFreefood();
        TypedQuery<Canteen> query = em.createNamedQuery("Canteen.findAll", Canteen.class);
        List<Canteen> results = query.getResultList();
        Gson gson = new Gson();
        String json = gson.toJson(results);
        return json;
    }
}
