package service;

import com.google.gson.Gson;
import domain.Employee;
import webservice.HTMLParserEmployees;

import javax.ejb.Stateless;
import javax.inject.Inject;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.TypedQuery;
import java.util.List;


@Stateless
public class EmployeeService {

    @Inject
    private HTMLParserEmployees parser;

    @PersistenceContext
    private EntityManager em;

    public String getEmployee(Long id){
        Employee employee = em.find(Employee.class, id);
        return employee.getNameAndTitle();
    }

    public String parseAndCreateEmployees(){
        parser.parseAndCreateEmployees();
        TypedQuery<Employee> query = em.createNamedQuery("Employee.findAll", Employee.class);
        List<Employee> results = query.getResultList();
        Gson gson = new Gson();
        String json = gson.toJson(results);
        return json;
    }

}
