package webservice;

import org.hibernate.boot.jaxb.SourceType;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import java.io.IOException;

public class HTMLParserCandle {

    String[] fmMiestnosti = new String[] {"FM-c.11","FM-c.12","FM-c.15","FM-c.16","FM-c.17","FM-c.18","FM-c.19",
            "FM-c.2","FM-c.20","FM-c.21","FM-c.22","FM-c.3","FM-c.305"};

    String[] nahradaFMMiestnosti = new String[] {"131","132","133","134","135","136","137","138","139","140",
            "141","142","143"};

    public static void main(String[] args) {

        HTMLParserCandle parser = new HTMLParserCandle();
        parser .parseCandle();

    }

    public void parseCandle() {
        try {

            Document doc;

            String urlMiestnosti = "https://candle.fmph.uniba.sk/miestnosti";
            doc = Jsoup.connect(urlMiestnosti).get();
            Document document = Jsoup.parse(doc.toString());


            Elements miestnosti = document.select("li");

            String miesta[] = new String[miestnosti.size() + 2];

            int i = 0;
            for (Element el : miestnosti) {
                //System.out.println("el: " + i + " " + el.text());

                if (!el.text().equals(null)) {
                    miesta[i] = el.text();
                }
                if (i == 253) {
                    break;
                }
                i++;
            }

            for (String miestnost : miesta) {
                System.out.println("toto je miestnost: " + miestnost);
                String url = "";
                if(this.isFMplace(miestnost)) {
                    System.out.println("nahrada miestnosti: " + this.changeNumberOfFMplace(miestnost));
                    url = String.valueOf(new StringBuilder(urlMiestnosti + "/" + this.changeNumberOfFMplace(miestnost)));
                }
                else {

                    url = String.valueOf(new StringBuilder(urlMiestnosti + "/" + miestnost));
                }
                doc = Jsoup.connect(url).get();
                Elements rozvrhy = doc.getElementsByClass("vysledky_podrobneho_hladania").select("tr");

                for (Element elem : rozvrhy) {
                    for (Element child : elem.children()) {
                        System.out.println(child.tagName() + ": " + child.text());
                    }
                }

            }

        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public Boolean isFMplace(String miestnost){
        for(String fm: fmMiestnosti) {
            if (miestnost.equals(fm)){
                return true;
            }
        }
        return false;
    }

    public String changeNumberOfFMplace(String fmPlace){
        for(int i = 0; i<= fmMiestnosti.length - 1; i++){
            if(fmMiestnosti[i].equals(fmPlace)){
                return nahradaFMMiestnosti[i];
            }
        }
        return "";
    }
}
